#include "utils.PRAP"
#include "Estudiante.hpp"

/*
 * Implementacion de la clase Estudiante
 */

/* Constantes */

const char *ER1 = "No te nota";
const char *ER2 = "Valor de la nota entre 0 a 10";
const char *ER3 = "Ja te nota";
const char *ER4 = "El DNI es incorrecte";


/* Constructoras */

Estudiante::Estudiante()
{
}


/* Destructora por defecto */

Estudiante::~Estudiante()
{
}

/* Modificadoras de los campos */

void Estudiante::crear_estudiante(int dni)
{
    if (dni<0) throw PRAPExcepcio(ER4);
    DNI = dni;
    tieneNota = false;

}

void Estudiante::anadir_nota(double nota)
{
    if (tieneNota)
	throw PRAPExcepcio(ER3);		        
    if (nota < 0 or nota > MAX_NOTA)
	throw PRAPExcepcio(ER2);		

    this->nota = nota;
    tieneNota = true;

}

void Estudiante::modificar_nota(double nota)
{ 
  if (not tieneNota)
	throw PRAPExcepcio(ER1);	
    if (nota < 0 or nota > MAX_NOTA)
	throw PRAPExcepcio(ER2);		
    this->nota = nota;
}


/* Consultoras de los campos */

bool Estudiante::tiene_nota() const
{
    return tieneNota;
}

double Estudiante::consultar_nota() const
{
    if (!tieneNota) throw PRAPExcepcio(ER1);
    return nota;
}

int Estudiante::consultar_DNI() const
{
    return DNI;
}

/* Entrada / Salida */

void Estudiante::leer_estudiante()
{
    crear_estudiante(readint());
    double x = readdouble();
    if (x>=0 && x<=MAX_NOTA)    anadir_nota(x);
}

void Estudiante::escribir_estudiante() const
{
    if (tiene_nota())
      cout << DNI << " " << nota << endl;
    else
	cout << DNI <<" NP" << endl;
}

///////////////////////////////////////////////////////////////////////////////
