#ifndef PALABRA_HPP
#define PALABRA_HPP

#include <vector>

/*
* Clase Palabra
*/

class Palabra
{
private:
  static const int MAXLONG = 20;
  static const char MARCAFINAL = '.';
  vector<char> letras;
  int longitud;

public:
  /* Constructoras */
  Palabra ();
  /* Se ejecuta automticamente al declarar una Palabra */

  Palabra (int cin);
  /* Crea una palabra leyendola del cin. Es til cuando se quiera que
     cada palabra leda sea un objeto nuevo.  El entero puede ser
     cualquiera */

  /* Consultoras de los campos */
  int longitud_maxima () const;
  /* Longitud mxima permitida por la implementacin */
 
  int long_pal () const;
  /* Longitud del parmetro implcito */
 
  char consultar_letra (int i) const;
  /* Devuelve la letra i-sima del parametro implcito si i est
   entre 1 y su longitud; si no, produce un error */

  bool marca () const;
 /* Retorna si el parametro implcito es un '.'. Para que sea util hay que
    escribir el punto separado de la palabra anterior */

  bool iguales (const Palabra & p) const;
 /* Retorna si p es igual al parametro implcito */

  /* Modificadoras de los campos */
  void anadir_letra (char c);
 /* El caracter c se aade al final del parametro implcito, si ste
    no tiene ya la longitud mxima permitida; si la tiene, se
    produce un error */

  /* Copiadora de la clase */
 /* No hace falta; con esta implementacin la asignacin normal funciona bien*/


  /* Entrada / Salida */
 
  void leer_palabra ();
  void escribir_palabra () const;
};

#endif
