#ifndef ARB_IO_INT
#define ARB_IO_INT
#include "Arbol.hpp"

// Lectura de un arbol binario de enteros, accion.  Los elementos se
// introducen en preorden: primero la raiz, despues el subarbol
// izquierdo y por ultimo el derecho.  Los arboles vacios se
// representan con la marca.

/* Ejemplo: el arbol 

                           1
                         /   \
                        2     3

 se lee 1 2 0 0 3 0 0 (o con los numeros en distintas lineas) */

inline void 
leer_arbol_int(Arbol<int>& a, int marca){
  Arbol<int> a1;
  Arbol<int> a2;
  int x;
  cin >> x;
  if (x!= marca) {
    leer_arbol_int(a1, marca);
    leer_arbol_int(a2, marca);
    a.plantar(x,a1,a2);
  }
}

// Escritura de un arbol binario de enteros, accion.  Los elementos se
// escriben en inorden: primero el subarbol izquierdo, despues la raiz
// y por ultimo el derecho.

inline void 
escribir_arbol_int( const Arbol<int> &a) {
  if (not a.es_nulo()) {
  Arbol<int> a1;
  Arbol<int> a2;
  a1.hi(a);
  a2.hd(a); 
  escribir_arbol_int(a1); 
  cout << " " << a.raiz();
  escribir_arbol_int(a2); 
  }
 
}
#endif
