/****************************************
 *        US DE PILES 			*
 ****************************************/

#include "PilaIOint.hpp"

bool pertpila_rec(Pila<int> &S, int i);
bool pertpila_it(Pila<int> &S, int i);

int main() 
{
  cout << "Escribe la pila, acabada en 0:" << endl;
  Pila<int> p;
  leer_pila_int(p,0);
  cout << "Escribe el elemento a buscar:" << endl;
  int valor=readint();
   
  Pila<int> copia(p); // copiamos para no destruir p

  cout << "Version iterativa o recursiva (escribe 1 o 2):" << endl;
  int i =readint(); bool es_trobat;
  if (i==1) es_trobat = pertpila_it(copia, valor);
  else if (i==2) es_trobat = pertpila_rec(copia, valor);
  else throw PRAPExcepcio("Hay que escribir 1 o 2");
 
  if( es_trobat)
    cout << "Est" << endl;
  else
    cout << "No est" << endl;
  cout << "Escribimos la pila original para ver que no se ha destruido:" << endl;
  escribir_pila_int(p);
}

/*
  Notemos que la pila se pasa por referencia, y puede resultar modificada,
  aunque se trate de una funcin
  Si deseamos conservar la pila original, hay que pasar una copia 
  No pasamos la pila por valor para evitar el coste de las copias
*/
bool pertpila_rec(Pila<int> &S, int i)
{
  bool ret;
  if(S.es_nula()) ret=false; 
  else 
    if (S.cima() == i ) ret=true;
    else {
      S.desapilar(); 
      ret=pertpila_rec(S,i);
    }
  return ret;
}

bool pertpila_it(Pila<int> &S, int i)
{
  bool ret=false;
  while(!S.es_nula() && !ret){
    ret = (S.cima() == i);
    S.desapilar();
  }
  return ret;
}





